unit SignalSettingsUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, AbNumEdit, _GClass, AbVMeter, Buttons;

type
  TSignalSettings_Form = class(TForm)
    AbVMeter1: TAbVMeter;
    ValueFromSpin: TAbNumSpin;
    ValueToSpin: TAbNumSpin;
    Label2: TLabel;
    DigitalFromSpin: TAbNumSpin;
    DigitalToSpin: TAbNumSpin;
    Label1: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Name1Edit: TEdit;
    Label5: TLabel;
    Name2Edit: TEdit;
    Label6: TLabel;
    ValueUnitEdit: TEdit;
    Label7: TLabel;
    ValueFormatEdit: TEdit;
    Label8: TLabel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure DigitalFromSpinValueChanged(Sender: TObject);
    procedure DigitalToSpinValueChanged(Sender: TObject);
    procedure ValueFromSpinValueChanged(Sender: TObject);
    procedure ValueToSpinValueChanged(Sender: TObject);
    procedure ValueUnitEditChange(Sender: TObject);
    procedure ValueFormatEditChange(Sender: TObject);
    procedure Name1EditChange(Sender: TObject);
    procedure Name2EditChange(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private-Deklarationen }
    procedure GetSettings;
  public
    { Public-Deklarationen }
  end;

var
  SignalSettings_Form: TSignalSettings_Form;
  SignSettings : TSignalSettings;
  SignSettingsOld : TSignalSettings;

implementation

{$R *.DFM}

procedure TSignalSettings_Form.FormCreate(Sender: TObject);
begin
  //save old settings for the undo-function, only used for prop-editor
  SignSettingsOld := TSignalSettings.Create;
  SignSettingsOld.Assign(AbVMeter1.SignalSettings);

  SignSettings := AbVMeter1.SignalSettings;
  GetSettings;
end;

procedure TSignalSettings_Form.GetSettings;
begin
  with SignSettings do begin
    ValueFromSpin.Value    := ValueFrom;
    ValueToSpin.Value      := ValueTo;
    DigitalFromSpin.Value  := DigitalFrom;
    DigitalToSpin.Value    := DigitalTo;
    ValueUnitEdit.Text     := ValueUnit;
    ValueFormatEdit.Text   := ValueFormat;
    Name1Edit.Text         := Name1;
    Name2Edit.Text         := Name2;
  end;
end;

procedure TSignalSettings_Form.FormDestroy(Sender: TObject);
begin
  SignSettingsOld.Free;
end;

procedure TSignalSettings_Form.DigitalFromSpinValueChanged(
  Sender: TObject);
begin
  SignSettings.DigitalFrom := DigitalFromSpin.ValueAsInt;
end;

procedure TSignalSettings_Form.DigitalToSpinValueChanged(Sender: TObject);
begin
  SignSettings.DigitalTo := DigitalToSpin.ValueAsInt;
end;

procedure TSignalSettings_Form.ValueFromSpinValueChanged(Sender: TObject);
begin
  SignSettings.ValueFrom := ValueFromSpin.ValueAsSingle;
end;

procedure TSignalSettings_Form.ValueToSpinValueChanged(Sender: TObject);
begin
  SignSettings.ValueTo := ValueToSpin.ValueAsSingle;
end;

procedure TSignalSettings_Form.ValueUnitEditChange(Sender: TObject);
begin
  SignSettings.ValueUnit := ValueUnitEdit.Text;
end;

procedure TSignalSettings_Form.ValueFormatEditChange(Sender: TObject);
begin
  SignSettings.ValueFormat := ValueFormatEdit.Text;
end;

procedure TSignalSettings_Form.Name1EditChange(Sender: TObject);
begin
  SignSettings.Name1 := Name1Edit.Text;
end;

procedure TSignalSettings_Form.Name2EditChange(Sender: TObject);
begin
  SignSettings.Name2 := Name2Edit.Text;
end;

procedure TSignalSettings_Form.BitBtn1Click(Sender: TObject);
begin
  close;
end;

end.
