unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  _GClass, AbVCInd, StdCtrls, AbNumEdit, AbCBitBt, Tabs, ExtCtrls, _AbProc,
  AbHSlide, AbVInd;

type
  TAbVCInd_Form = class(TForm)
    ColorDialog1: TColorDialog;
    FontDialog1: TFontDialog;
    Label13: TLabel;
    Label18: TLabel;
    Label28: TLabel;
    Label29: TLabel;
    AbHSlider1: TAbHSlider;
    AbHSlider2: TAbHSlider;
    AbHSlider3: TAbHSlider;
    AbHSlider4: TAbHSlider;
    Timer1: TTimer;
    ColorBtn: TAbColBitBtn;
    Label19: TLabel;
    Label20: TLabel;
    CourseBkColorBtn: TAbColBitBtn;
    RollBkColorBtn: TAbColBitBtn;
    Label21: TLabel;
    Label22: TLabel;
    ArrShouldColBtn: TAbColBitBtn;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    ColorSkyBtn: TAbColBitBtn;
    ColorGroundBtn: TAbColBitBtn;
    ScalePanel: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label14: TLabel;
    AngleSpin: TAbNumSpin;
    AngleModeSelBox: TComboBox;
    AbLineSettingsPanel: TPanel;
    Label3: TLabel;
    Label4: TLabel;
    PenColorSelBtn: TAbColBitBtn;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    VisibleCheckBox: TCheckBox;
    OffsetSpin: TAbNumSpin;
    PenModeSelBox: TComboBox;
    PenStyleSelBox: TComboBox;
    PenWidthSpin: TAbNumSpin;
    TabSet1: TTabSet;
    TextOffsetXSpin: TAbNumSpin;
    TextOffsetYSpin: TAbNumSpin;
    TextAlignmentSelBox: TComboBox;
    TextEdit: TEdit;
    FontButton: TButton;
    ScaleTabSet: TTabSet;
    BevelPanel: TPanel;
    ColFromBtn: TAbColBitBtn;
    ColToBtn: TAbColBitBtn;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    SwapColBtn: TAbColBitBtn;
    BevelWidthSpin: TAbNumSpin;
    TabSet2: TTabSet;
    OuterSpacingSpin: TAbNumSpin;
    InnerSpacingSpin: TAbNumSpin;
    ArrowSizeSpin: TAbNumSpin;
    ArrShouldSizeSpin: TAbNumSpin;
    ArrShouldOffsSpin: TAbNumSpin;
    ScaleHeightSpin: TAbNumSpin;
    LengthSpin: TAbNumSpin;
    AbVCInd1: TAbVCInd;
    procedure FormCreate(Sender: TObject);
    procedure AngleSpinValueChanged(Sender: TObject);
    procedure AngleModeSelBoxChange(Sender: TObject);
    procedure TabSet1Change(Sender: TObject; NewTab: Integer;
      var AllowChange: Boolean);
    procedure LengthSpinValueChanged(Sender: TObject);
    procedure PenWidthSpinValueChanged(Sender: TObject);
    procedure OffsetSpinValueChanged(Sender: TObject);
    procedure PenModeSelBoxChange(Sender: TObject);
    procedure PenStyleSelBoxChange(Sender: TObject);
    procedure VisibleCheckBoxClick(Sender: TObject);
    procedure PenColorSelBtnClick(Sender: TObject);
    procedure TextOffsetXSpinChange(Sender: TObject);
    procedure TextOffsetYSpinChange(Sender: TObject);
    procedure TextAlignmentSelBoxChange(Sender: TObject);
    procedure TextEditChange(Sender: TObject);
    procedure FontButtonClick(Sender: TObject);
    procedure ScaleTabSetChange(Sender: TObject; NewTab: Integer;
      var AllowChange: Boolean);
    procedure TabSet2Change(Sender: TObject; NewTab: Integer;
      var AllowChange: Boolean);
    procedure BevelWidthSpinChange(Sender: TObject);
    procedure ColFromBtnStatusChanged(Sender: TObject);
    procedure ColToBtnStatusChanged(Sender: TObject);
    procedure SwapColBtnStatusChanged(Sender: TObject);
    procedure ColorBtnStatusChanged(Sender: TObject);
    procedure OuterSpacingSpinValueChanged(Sender: TObject);
    procedure InnerSpacingSpinValueChanged(Sender: TObject);
    procedure CourseBkColorBtnStatusChanged(Sender: TObject);
    procedure RollBkColorBtnStatusChanged(Sender: TObject);
    procedure ArrShouldColBtnStatusChanged(Sender: TObject);
    procedure ArrowSizeSpinValueChanged(Sender: TObject);
    procedure ArrShouldSizeSpinValueChanged(Sender: TObject);
    procedure ArrShouldOffsSpinValueChanged(Sender: TObject);
    procedure ScaleHeightSpinValueChanged(Sender: TObject);
    procedure ColorSkyBtnStatusChanged(Sender: TObject);
    procedure ColorGroundBtnStatusChanged(Sender: TObject);
    procedure AbHSlider1ValueChange(Sender: TObject);
    procedure AbHSlider2ValueChange(Sender: TObject);
    procedure AbHSlider3ValueChange(Sender: TObject);
    procedure AbHSlider4ValueChange(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    procedure SetScale(scl : TAbScale);
    procedure SetLine(ln : TAbLineSettings);
    procedure SetBevel(bl : TAbBevelSettings);
  end;

var
  AbVCInd_Form: TAbVCInd_Form;
  Scale : TAbScale;
  Line : TAbLineSettings;
  bvl  : TAbBevelSettings;

implementation

{$R *.DFM}

procedure TAbVCInd_Form.SetScale(scl : TAbScale);
begin
  Scale := scl;
  AngleSpin.Value := Scale.Angle;
  AngleModeSelBox.ItemIndex := Ord(Scale.AngleMode);
  Line := Scale.StepLines;
  TextOffsetXSpin.Value := Scale.TextOffsetX;
  TextOffsetYSpin.Value := Scale.TextOffsetY;
  TextAlignmentSelBox.ItemIndex := Ord(Scale.TextAlignment);
  TextEdit.Text := Scale.Text;
  TabSet1.TabIndex := 0;
  SetLine(Scale.StepLines);
end;

procedure TAbVCInd_Form.SetLine(ln : TAbLineSettings);
begin
  Line := ln;
  LengthSpin.Value := Line.Length;
  PenWidthSpin.Value := Line.Pen.Width;
  OffsetSpin.Value := Line.Offset;
  PenModeSelBox.ItemIndex := Ord(Line.Pen.Mode);
  PenStyleSelBox.ItemIndex := Ord(Line.Pen.Style);
  PenColorSelBtn.ColorOn := Line.Pen.Color;
  PenColorSelBtn.ColorOff := Line.Pen.Color;
  VisibleCheckBox.Checked := Line.Visible;
end;

procedure TAbVCInd_Form.SetBevel(bl : TAbBevelSettings);
begin
  bvl := bl;
  ColFromBtn.ColorOff := bvl.ColorFrom;
  ColFromBtn.ColorOn := bvl.ColorFrom;
  ColToBtn.ColorOff := bvl.ColorTo;
  ColToBtn.ColorOn := bvl.ColorTo;
  BevelWidthSpin.Value := bvl.Width;
end;

procedure TAbVCInd_Form.FormCreate(Sender: TObject);
begin
  SetScale(AbVCInd1.CourseScale);
  SetBevel(AbVCInd1.BevelOuter);
  SetLine(AbVCInd1.CourseScale.StepLines);
//  AbVCInd1.BeginUpdate;
  OuterSpacingSpin.Value := AbVCInd1.OuterSpacing;
  InnerSpacingSpin.Value := AbVCInd1.InnerSpacing;
  ColorBtn.ColorOff := AbVCInd1.Color;
  ColorBtn.ColorOn := AbVCInd1.Color;
  CourseBkColorBtn.ColorOn := AbVCInd1.CourseBkColor;
  CourseBkColorBtn.ColorOff := AbVCInd1.CourseBkColor;
  RollBkColorBtn.ColorOn := AbVCInd1.RollBkColor;
  RollBkColorBtn.ColorOff := AbVCInd1.RollBkColor;
  ArrShouldColBtn.ColorOn := AbVCInd1.ArrShouldCol;
  ArrShouldColBtn.ColorOff := AbVCInd1.ArrShouldCol;

  ArrowSizeSpin.Value := AbVCInd1.ArrowSize;
  ArrShouldSizeSpin.Value := AbVCInd1.ArrShouldSize;
  ArrShouldOffsSpin.Value := AbVCInd1.ArrShouldOffs;

  ScaleHeightSpin.Value := AbVCInd1.ScaleHeight;

  ColorSkyBtn.ColorOn  := AbVCInd1.ColorSky;
  ColorSkyBtn.ColorOff := AbVCInd1.ColorSky;

  ColorGroundBtn.ColorOn  := AbVCInd1.ColorGround;
  ColorGroundBtn.ColorOff := AbVCInd1.ColorGround;
//  AbVCInd1.EndUpdate;

end;

procedure TAbVCInd_Form.AngleSpinValueChanged(Sender: TObject);
begin
  Scale.Angle := AngleSpin.ValueAsInt;
end;

procedure TAbVCInd_Form.AngleModeSelBoxChange(Sender: TObject);
begin
  Scale.AngleMode := TAngleMode(AngleModeSelBox.ItemIndex);
end;

procedure TAbVCInd_Form.TabSet1Change(Sender: TObject; NewTab: Integer;
  var AllowChange: Boolean);
begin
  if NewTab = 0 then SetLine(Scale.StepLines)
  else SetLine(Scale.SubStepLines);
end;

procedure TAbVCInd_Form.LengthSpinValueChanged(Sender: TObject);
begin
  Line.Length := LengthSpin.ValueAsInt;
end;

procedure TAbVCInd_Form.PenWidthSpinValueChanged(Sender: TObject);
begin
  Line.Pen.Width := PenWidthSpin.ValueAsInt;
end;

procedure TAbVCInd_Form.OffsetSpinValueChanged(Sender: TObject);
begin
  Line.Offset := OffsetSpin.ValueAsInt;
end;

procedure TAbVCInd_Form.PenModeSelBoxChange(Sender: TObject);
begin
  Line.Pen.Mode := TPenMode(PenModeSelBox.ItemIndex);
end;

procedure TAbVCInd_Form.PenStyleSelBoxChange(Sender: TObject);
begin
  Line.Pen.Style := TPenStyle(PenStyleSelBox.ItemIndex);
end;

procedure TAbVCInd_Form.VisibleCheckBoxClick(Sender: TObject);
begin
  Line.Visible := VisibleCheckBox.Checked;
end;

procedure TAbVCInd_Form.PenColorSelBtnClick(Sender: TObject);
begin
  if not PenColorSelBtn.Checked then exit;
  ColorDialog1.Color := Line.Pen.Color;
  if ColorDialog1.Execute then begin
    PenColorSelBtn.ColorOn := ColorDialog1.Color;
    PenColorSelBtn.ColorOff := ColorDialog1.Color;
    Line.Pen.Color := ColorDialog1.Color;
  end;
end;

procedure TAbVCInd_Form.TextOffsetXSpinChange(Sender: TObject);
begin
  Scale.TextOffsetX := TextOffsetXSpin.ValueAsInt;
end;

procedure TAbVCInd_Form.TextOffsetYSpinChange(Sender: TObject);
begin
  Scale.TextOffsetY := TextOffsetYSpin.ValueAsInt;
end;

procedure TAbVCInd_Form.TextAlignmentSelBoxChange(Sender: TObject);
begin
  Scale.TextAlignment := toPos(TextAlignmentSelBox.ItemIndex);
end;

procedure TAbVCInd_Form.TextEditChange(Sender: TObject);
begin
  Scale.Text := TextEdit.Text;
end;

procedure TAbVCInd_Form.FontButtonClick(Sender: TObject);
begin
  FontDialog1.Font.Assign(Scale.Font);
  if FontDialog1.Execute then Scale.Font.Assign(FontDialog1.Font);
end;

procedure TAbVCInd_Form.ScaleTabSetChange(Sender: TObject; NewTab: Integer;
  var AllowChange: Boolean);
begin
  if NewTab = 0 then
    SetScale(AbVCInd1.CourseScale)
  else if NewTab = 1 then
    SetScale(AbVCInd1.RollScale)
  else if NewTab = 2 then
    {SetScale(AbVCInd1.PitchScale)};
end;

procedure TAbVCInd_Form.TabSet2Change(Sender: TObject; NewTab: Integer;
  var AllowChange: Boolean);
begin
  case NewTab of
    0: SetBevel(AbVCInd1.BevelOuter);
    1: SetBevel(AbVCInd1.BevelMiddle);
    2: SetBevel(AbVCInd1.BevelInner);
  end;
end;

procedure TAbVCInd_Form.BevelWidthSpinChange(Sender: TObject);
begin
  bvl.Width := BevelWidthSpin.ValueAsInt;
end;

procedure TAbVCInd_Form.ColFromBtnStatusChanged(Sender: TObject);
begin
  if not ColFromBtn.Checked then exit;
  ColorDialog1.Color := Bvl.ColorFrom;
  if ColorDialog1.Execute then begin
    ColFromBtn.ColorOn := ColorDialog1.Color;
    ColFromBtn.ColorOff := ColorDialog1.Color;
    Bvl.ColorFrom := ColorDialog1.Color;
  end;
end;

procedure TAbVCInd_Form.ColToBtnStatusChanged(Sender: TObject);
begin
  if not ColToBtn.Checked then exit;
  ColorDialog1.Color := Bvl.ColorTo;
  if ColorDialog1.Execute then begin
    ColToBtn.ColorOn := ColorDialog1.Color;
    ColToBtn.ColorOff := ColorDialog1.Color;
    Bvl.ColorTo := ColorDialog1.Color;
  end;
end;

procedure TAbVCInd_Form.SwapColBtnStatusChanged(Sender: TObject);
begin
  if not SwapColBtn.Checked then exit;
  Bvl.SwapColors;
  SetBevel(Bvl);
end;

procedure TAbVCInd_Form.ColorBtnStatusChanged(Sender: TObject);
begin
  if not ColorBtn.Checked then exit;
  ColorDialog1.Color := AbVCInd1.Color;
  if ColorDialog1.Execute then begin
    ColorBtn.ColorOn := ColorDialog1.Color;
    ColorBtn.ColorOff := ColorDialog1.Color;
    AbVCInd1.Color := ColorDialog1.Color;
  end;
end;

procedure TAbVCInd_Form.OuterSpacingSpinValueChanged(Sender: TObject);
begin
  AbVCInd1.OuterSpacing := OuterSpacingSpin.ValueAsInt;
end;

procedure TAbVCInd_Form.InnerSpacingSpinValueChanged(Sender: TObject);
begin
  AbVCInd1.InnerSpacing := InnerSpacingSpin.ValueAsInt;
end;

procedure TAbVCInd_Form.CourseBkColorBtnStatusChanged(Sender: TObject);
begin
  if not CourseBkColorBtn.Checked then exit;
  ColorDialog1.Color := AbVCInd1.CourseBkColor;
  if ColorDialog1.Execute then begin
    CourseBkColorBtn.ColorOn := ColorDialog1.Color;
    CourseBkColorBtn.ColorOff := ColorDialog1.Color;
    AbVCInd1.CourseBkColor := ColorDialog1.Color;
  end;
end;

procedure TAbVCInd_Form.RollBkColorBtnStatusChanged(Sender: TObject);
begin
  if not RollBkColorBtn.Checked then exit;
  ColorDialog1.Color := AbVCInd1.RollBkColor;
  if ColorDialog1.Execute then begin
    RollBkColorBtn.ColorOn := ColorDialog1.Color;
    RollBkColorBtn.ColorOff := ColorDialog1.Color;
    AbVCInd1.RollBkColor := ColorDialog1.Color;
  end;
end;

procedure TAbVCInd_Form.ArrShouldColBtnStatusChanged(Sender: TObject);
begin
  if not ArrShouldColBtn.Checked then exit;
  ColorDialog1.Color := AbVCInd1.ArrShouldCol;
  if ColorDialog1.Execute then begin
    ArrShouldColBtn.ColorOn  := ColorDialog1.Color;
    ArrShouldColBtn.ColorOff := ColorDialog1.Color;
    AbVCInd1.ArrShouldCol    := ColorDialog1.Color;
  end;
end;

procedure TAbVCInd_Form.ArrowSizeSpinValueChanged(Sender: TObject);
begin
  AbVCInd1.ArrowSize := ArrowSizeSpin.ValueAsInt;
end;

procedure TAbVCInd_Form.ArrShouldSizeSpinValueChanged(Sender: TObject);
begin
  AbVCInd1.ArrShouldSize := ArrShouldSizeSpin.ValueAsInt;
end;

procedure TAbVCInd_Form.ArrShouldOffsSpinValueChanged(Sender: TObject);
begin
  AbVCInd1.ArrShouldOffs := ArrShouldOffsSpin.ValueAsInt;
end;

procedure TAbVCInd_Form.ScaleHeightSpinValueChanged(Sender: TObject);
begin
  AbVCInd1.ScaleHeight := ScaleHeightSpin.ValueAsInt;
end;

procedure TAbVCInd_Form.ColorSkyBtnStatusChanged(Sender: TObject);
begin
  if not ColorSkyBtn.Checked then exit;
  ColorDialog1.Color := AbVCInd1.ColorSky;
  if ColorDialog1.Execute then begin
    ColorSkyBtn.ColorOn  := ColorDialog1.Color;
    ColorSkyBtn.ColorOff := ColorDialog1.Color;
    AbVCInd1.ColorSky    := ColorDialog1.Color;
  end;
end;

procedure TAbVCInd_Form.ColorGroundBtnStatusChanged(Sender: TObject);
begin
  if not ColorGroundBtn.Checked then exit;
  ColorDialog1.Color := AbVCInd1.ColorGround;
  if ColorDialog1.Execute then begin
    ColorGroundBtn.ColorOn  := ColorDialog1.Color;
    ColorGroundBtn.ColorOff := ColorDialog1.Color;
    AbVCInd1.ColorGround    := ColorDialog1.Color;
  end;
end;

procedure TAbVCInd_Form.AbHSlider1ValueChange(Sender: TObject);
begin
  AbVCInd1.Pitch :=  AbHSlider1.Value;
end;

procedure TAbVCInd_Form.AbHSlider2ValueChange(Sender: TObject);
begin
  AbVCInd1.Roll :=  AbHSlider2.Value;
end;

procedure TAbVCInd_Form.AbHSlider3ValueChange(Sender: TObject);
begin
  AbVCInd1.Course :=  AbHSlider3.Value;
end;

procedure TAbVCInd_Form.AbHSlider4ValueChange(Sender: TObject);
begin
  AbVCInd1.CourseShould :=  AbHSlider4.Value;
end;

procedure TAbVCInd_Form.Timer1Timer(Sender: TObject);
begin
  close;
end;

end.
